## Check the activity goal states / fail states
# @s = player

# Exit codes:
# 0 = continue
# 1 = success
# 2 = program error
# 3 = program closed
# 4 = code ended without reaching goal
# 5 = didn't run the right code for the wheelchair person

## Prep
# If the player has started running code, add code_started
tag @s[codebuilder={code_status="in_progress"},tag=!code_started] add code_started

## Run activity_check while code is running
# If not awaiting input
execute if entity @s[tag=code_started] if score .seq2 global matches ..19 run function seq/12_activity_check
execute if entity @s[tag=code_started] if score .seq2 global matches 21..153 run function seq/12_activity_check
execute if entity @s[tag=code_started] if score .seq2 global matches 155..287 run function seq/12_activity_check
execute if entity @s[tag=code_started] if score .seq2 global matches 289.. run function seq/12_activity_check

# For inputs
execute if score .seq2 global matches 020 if score .output global matches 1..2 run function seq/12_activity_check
execute if score .seq2 global matches 154 if score .output global matches 1..2 run function seq/12_activity_check
execute if score .seq2 global matches 288 if score .output global matches 2    run function seq/12_activity_check

## Exit Codes
# Exit code 1 if the code is successfully completed
execute if score .seq2 global matches 529 run scoreboard players set .exit global 1

# Exit code 2 if there's a syntax error
execute if entity @s[codebuilder={code_status="error"},tag=code_started] run scoreboard players set .exit global 2

# Exit code 3 if the player closed the program early
execute if entity @s[codebuilder={code_status="not_started"},tag=code_started] run scoreboard players set .exit global 3

# Exit code 4 if the code ends early
execute if entity @s[codebuilder={code_status="succeeded"},tag=code_started] if score .seq2 global matches ..528 run scoreboard players set .exit global 4

# Exit code 5 if they ran the wrong code for step 2
execute if score .seq2 global matches 288 if score .output global matches 1 run scoreboard players set .exit global 5

## Debug
#execute if score .output global matches 1 run say 1
#execute if score .output global matches 2 run say 2
#execute if score .output global matches 3 run say 3
#execute if score .output global matches 4 run say 4

## Cleanup
# Reset codes
scoreboard players set .output global 0

# Exit if there is an exit code
execute if score .exit global matches 1.. run codebuilder runtime stop @s
execute if score .exit global matches 1.. run tag @s remove code_started
execute if score .exit global matches 1.. run scoreboard players add .seq global 1