## Check the activity goal states / fail states
# @s = player

# Exit codes:
# 0 = continue
# 1 = success
# 2 = program error
# 3 = program closed
# 4 = didn't check for sprinkler
# 5 = didn't finish the program
# 6 = went out of bounds / tried to mow

## Prep
# If the player has started running code, add code_started
tag @s[codebuilder={code_status="in_progress"},tag=!code_started] add code_started

## Exit Codes
# Exit code 1 if the code is successfully completed
execute if entity @s[codebuilder={code_status="succeeded"},tag=code_started] if score .seq2 global matches 63..64 run scoreboard players set .exit global 1

# Exit code 2 if there's a syntax error
execute if entity @s[codebuilder={code_status="error"},tag=code_started] run scoreboard players set .exit global 2

# Exit code 3 if the player closed the program early
execute if entity @s[codebuilder={code_status="not_started"},tag=code_started] run scoreboard players set .exit global 3

# Exit code 4 if they ever get output 1
execute if score .output global matches 1 run scoreboard players set .exit global 4

# Exit code 5 if the code ends early
execute if entity @s[codebuilder={code_status="succeeded"},tag=code_started] if score .seq2 global matches ..62 run scoreboard players set .exit global 5

# Exit code 6 if they do anything after reaching final subsequence
execute if score .seq2 global matches 65.. if score .output global matches 2.. run scoreboard players set .exit global 6

## Animation
# If they get another output, check if it's the correct one in the sequence and move the lawnmower accordingly
execute if score .output global matches 2.. as @e[type=rwm:lawnmower,tag=scene2] at @s run function seq/22_activity_check

## Debug
#execute if score .output global matches 1 run say Mow
#execute if score .output global matches 2 run say Mow (check)
#execute if score .output global matches 3 run say Forward
#execute if score .output global matches 4 run say New

## Cleanup
# Reset codes
scoreboard players set .output global 0

# Exit if there is an exit code
execute if score .exit global matches 1.. run codebuilder runtime stop @s
execute if score .exit global matches 1.. run tag @s remove code_started
execute if score .exit global matches 1.. run scoreboard players add .seq global 1