## Check the activity goal states / fail states
# @s = player

# Exit codes:
# 0 = continue
# 1 = code work
# 2 = code no work

## Prep
# If the player has started running code, add code_started
tag @s[codebuilder={code_status="in_progress"},tag=!code_started] add code_started

## Check for correct input
execute if score .output global matches 1.. run function seq/32_activity_check

## Exit Codes
# Exit code 1 if the code is successfully completed
execute if score .seq2 global matches 6.. run scoreboard players set .exit global 1

# Exit code 3 if there's a syntax error
execute if entity @s[codebuilder={code_status="error"},tag=code_started] run scoreboard players set .exit global 3

# Exit code 4 if the player closed the program early
execute if entity @s[codebuilder={code_status="not_started"},tag=code_started] run scoreboard players set .exit global 4

# Exit code 5 if the code ends early
execute if entity @s[codebuilder={code_status="succeeded"},tag=code_started] if score .seq2 global matches ..5 run scoreboard players set .exit global 5

## Debug
#execute if score .output global matches 1 run say 1
#execute if score .output global matches 2 run say 2
#execute if score .output global matches 3 run say 3
#execute if score .output global matches 4 run say 4
#execute if score .output global matches 5 run say 5
#execute if score .output global matches 6 run say 6
#execute if score .output global matches 7 run say 7
#execute if score .output global matches 8 run say 8
#execute if score .output global matches 8 run say 9

## Cleanup
# Reset codes
scoreboard players set .output global 0

# Exit if there is an exit code
execute if score .exit global matches 1.. run codebuilder runtime stop @s
execute if score .exit global matches 1.. run tag @s remove code_started
execute if score .exit global matches 1.. run scoreboard players add .seq global 1