## Check the activity goal states / fail states
# @s = player

# Exit codes:
# 0 = continue
# 1 = success
# 2 = program error
# 3 = program closed
# 4 = code ended without reaching goal
# 5 = ran the wrong code / redundant code

# Display the marks
execute at @e[type=rwm:time_agent,tag=incorrect] run particle rwm:cross
execute at @e[type=rwm:time_agent,tag=correct]  run particle rwm:check

## Prep
# If the player has started running code, add code_started
tag @s[codebuilder={code_status="in_progress"},tag=!code_started] add code_started

# Give wrong answer tag if redundant input is given
execute if score .output global matches 11 if entity @s[tag=52.obj1] run tag @s add 52.wrong_answer
execute if score .output global matches 21 if entity @s[tag=52.obj2] run tag @s add 52.wrong_answer
execute if score .output global matches 34 if entity @s[tag=52.obj3] run tag @s add 52.wrong_answer
execute if score .output global matches 43 if entity @s[tag=52.obj4] run tag @s add 52.wrong_answer

# Give wrong answer tag if they ran any incorrect code
execute if score .output global matches 1.. unless score .output global matches 11 unless score .output global matches 21 unless score .output global matches 34 unless score .output global matches 43 run tag @s add 52.wrong_answer

## Check for correct input
execute if score .output global matches 11 run tag @s add 52.obj1
execute if score .output global matches 21 run tag @s add 52.obj2
execute if score .output global matches 34 run tag @s add 52.obj3
execute if score .output global matches 43 run tag @s add 52.obj4

## Exit Codes
# Exit code 1 if the code is successfully completed
execute if entity @s[codebuilder={code_status="succeeded"},tag=code_started,tag=52.obj1,tag=52.obj2,tag=52.obj3,tag=52.obj4] run scoreboard players set .exit global 1

# Exit code 2 if there's a syntax error
execute if entity @s[codebuilder={code_status="error"},tag=code_started] run scoreboard players set .exit global 2

# Exit code 3 if the player closed the program early
execute if entity @s[codebuilder={code_status="not_started"},tag=code_started] run scoreboard players set .exit global 3

# Exit code 4 if the code ends early
execute if entity @s[codebuilder={code_status="succeeded"},tag=code_started,tag=!52.obj1] run scoreboard players set .exit global 4
execute if entity @s[codebuilder={code_status="succeeded"},tag=code_started,tag=!52.obj2] run scoreboard players set .exit global 4
execute if entity @s[codebuilder={code_status="succeeded"},tag=code_started,tag=!52.obj3] run scoreboard players set .exit global 4
execute if entity @s[codebuilder={code_status="succeeded"},tag=code_started,tag=!52.obj4] run scoreboard players set .exit global 4

# Exit code 5 if they have the wrong answer tag
execute if entity @s[codebuilder={code_status="succeeded"},tag=code_started,tag=52.wrong_answer] run scoreboard players set .exit global 5

## Debug
#execute if score .output global matches 11 run say 11
#execute if score .output global matches 12 run say 12
#execute if score .output global matches 13 run say 13
#execute if score .output global matches 14 run say 14
#execute if score .output global matches 21 run say 21
#execute if score .output global matches 22 run say 22
#execute if score .output global matches 23 run say 23
#execute if score .output global matches 24 run say 24
#execute if score .output global matches 31 run say 31
#execute if score .output global matches 32 run say 32
#execute if score .output global matches 33 run say 33
#execute if score .output global matches 34 run say 34
#execute if score .output global matches 41 run say 41
#execute if score .output global matches 42 run say 42
#execute if score .output global matches 43 run say 43
#execute if score .output global matches 44 run say 44

## Cleanup
# Reset codes
scoreboard players set .output global 0

# Set the "correct" particle tags on exit
execute if score .exit global matches 1.. run tag @e[type=rwm:time_agent] remove correct
execute if score .exit global matches 1.. run tag @e[type=rwm:time_agent] remove incorrect
execute if score .exit global matches 1.. if entity @s[tag=52.obj1] run tag @e[tag=red_agent] add correct
execute if score .exit global matches 1.. if entity @s[tag=52.obj2] run tag @e[tag=yellow_agent] add correct
execute if score .exit global matches 1.. if entity @s[tag=52.obj3] run tag @e[tag=blue_agent] add correct
execute if score .exit global matches 1.. if entity @s[tag=52.obj4] run tag @e[tag=green_agent] add correct
execute if score .exit global matches 1.. run tag @e[type=rwm:time_agent,tag=scene5,tag=!correct] add incorrect

# Exit if there is an exit code
execute if score .exit global matches 1.. run codebuilder runtime stop @s
execute if score .exit global matches 1.. run tag @s remove code_started
execute if score .exit global matches 1.. run tag @s remove 52.obj1
execute if score .exit global matches 1.. run tag @s remove 52.obj2
execute if score .exit global matches 1.. run tag @s remove 52.obj3
execute if score .exit global matches 1.. run tag @s remove 52.obj4
execute if score .exit global matches 1.. run tag @s remove 52.wrong_answer
execute if score .exit global matches 1.. run scoreboard players add .seq global 1